=== debian/changelog ===
darktable (1.6.8-1mx150+1) mx; urgency=low

  * Rebuild for MEPIS 15.

 -- Steven Pusser (Stevo) <maintainer@mepiscommunity.org>  Tue, 11 Aug 2015 16:37:51 -0700

darktable (1.6.8-1) unstable; urgency=medium

  * New upstream bugfix release.

 -- David Bremner <bremner@debian.org>  Fri, 31 Jul 2015 16:35:10 +0200

darktable (1.6.7-2) unstable; urgency=medium

  * Bug fix: "Export is broken err [imageio_storage_disk] could not export
    to file", thanks to Roman Lebedev (Closes: #792209).

 -- David Bremner <bremner@debian.org>  Tue, 14 Jul 2015 07:17:34 +0200

darktable (1.6.7-1) unstable; urgency=medium

  * Bug fix: "no longer ships gphoto2-{, port-}config which breaks
    FindGphoto2.cmake", thanks to Emilio Pozuelo Monfort (Closes:
    #783821).
  * Bug fix: "CVE-2015-3885: input sanitization flaw leading to buffer
    overflow", thanks to Salvatore Bonaccorso (Closes: #786792).

 -- David Bremner <bremner@debian.org>  Sun, 07 Jun 2015 23:23:34 +0200

darktable (1.6.6-2) unstable; urgency=medium

  * Bug fix: "Install appstream appdata", thanks to Marcus Lundblad
    (Closes: #785663).

 -- David Bremner <bremner@debian.org>  Tue, 19 May 2015 17:12:18 +0200
